function [ret,safe_sample] = detectorPSK(I_Qsamples,p)
safe_sample = 0;
% Assuming 2-PSK training sequence modulation
% Create decoding values
valuesI = [3 -3 3]/sqrt(5);
valuesQ = [1 -1 1]/sqrt(5);
angle_limits = [pi/2+0.321 3*pi/2+0.321];

% Decode signal
I_decoded = 0; Q_decoded = 0;
for i=1:length(I_Qsamples)
   % I samples
   k=1;
   curr_angle = angle(I_Qsamples);
   if curr_angle <0
       curr_angle = curr_angle + 2*pi;
   end
   while curr_angle > angle_limits(k)
       k = k + 1;
       if k >length(angle_limits)
           break
       end
   end
   I_decoded(i) = valuesI(k);
   Q_decoded(i) = valuesQ(k);
   
   if abs(real(I_Qsamples(i)) - I_decoded(i)) < p.safe_distance && abs(imag(I_Qsamples(i)) - Q_decoded(i)) < p.safe_distance
      safe_sample = 1;
   end 
end

ret = (I_decoded + 1i* Q_decoded);