function [ret,safe_sample] = detectorQAM(samples, M,p)
if p.costas_safe_module == 1
    safe_sample = 0;
else 
    safe_sample = 1;
end
% Assuming M-QAM modulation (square constellations)
% Create decoding values

limits = [-2 0 2]/sqrt(5);
values = [-3 -1 1 3]/sqrt(5);

% Decode signal
I_decoded = 0; Q_decoded = 0;
for i=1:length(real(samples))
   % I samples
   k=1;
   while real(samples(i)) > limits(k)
       k = k + 1;
       if k >length(limits)
           break
       end
   end
   I_decoded(i) = values(k); 
   % Q samples
   k=1;
   while imag(samples(i)) > limits(k)
       k = k + 1;
       if k >length(limits)
           break
       end
   end
   Q_decoded(i) = values(k);
   
   % Checks if the sample is close to the decoded point
   if abs(real(samples(i)) - I_decoded(i)) < p.safe_distance && abs(imag(samples(i)) - Q_decoded(i)) < p.safe_distance
      safe_sample = 1;
   end
end

ret = (I_decoded + 1i* Q_decoded);