clear all
simul = 2;      % 1 - Plot progress in phase tracking
                % 2 - Plot st.dev as function of number of symbols         
switch simul
case 1
    load('simulator_data.mat')  % Loads data stored by simul1.m  
    % Plot progress in phase tracking
    figure
    hold on
    plot(params.added_error*180/pi,'k')
    plot(1:params.nr_of_periods,sim1_tracking*180/pi)
    hold off
    xlabel('Antall symboler brukt i fasegjenvinningen')
    ylabel('Fase [grader]')
    legend_table(1,:) = 'Fasefeil ';
    for i=1:nr_of_simulations
        if sim1_SNR(i,:) < 10
            legend_table(i+1,:) = [num2str(sim1_SNR(i,:)) '  dB    '];
        else
            legend_table(i+1,:) = [num2str(sim1_SNR(i,:)) ' dB    '];
        end
    end
    legend(legend_table)
    grid on
case 2
    load('simulator_data.mat')  % Loads data stored by simul1.m    
    figure
    hold on
    plot(1:params.nr_of_periods,sqrt(sim1_variance)*180/pi)
    hold off
    xlabel('Punktpr??ver')
    ylabel('RMS-fasefeil [grader]')
    legend([repmat('SNR = ',length(sim1_SNR),1) num2str(sim1_SNR) repmat(' dB,  R = ',length(sim1_SNR),1) num2str(safe_distance_table') repmat(', \gamma = 2^{',length(sim1_SNR),1) num2str(log10(gamma_table(1:length(sim1_SNR))')/log10(2)) repmat('}, \rho = 2^{',length(sim1_SNR),1) num2str(log10(rho_table(1:length(sim1_SNR))')/log10(2)) repmat('}',length(sim1_SNR),1)],'Location','SouthEast')
    grid on
end